/*****************************************************************************/
/******                                                                 ******/
/******                   Primeiro Semestre de 2001                     ******/
/******                                                                 ******/
/******      Primeiro programa de MAC-438 Programacao Concorrente       ******/
/******      Data de entrega: Quarta feira 01 de Setembo                ******/
/******      Professor: Francisco Reverbel                              ******/
/******                                                                 ******/
/******      Nomes:                                                     ******/
/******                                                                 ******/
/******        Hugo Kotsubo                       N. USP: 2957620       ******/
/******        Levi Fukumori                      N. USP: 2995112       ******/
/******                                                                 ******/
/*****************************************************************************/

/*****************************************************************************/
/******                           CONSUMIDOR.C                          ******/
/*****************************************************************************/

#include "sharemem.h"

/********************     CONSUMIDOR     ********************/

int main() {

  // variaveis para guardar os tempos de disputa da regiao critica
  double MaxTime, MinTime, MedTime;

  int parou; /* Varivel de controle,  explicada mais abaixo */

  /* Process ID do CONSUMIDOR */
  long ProcessID_cons;

  /* Process ID do PRODUTOR */
  long ProcessID_prod;

  /* ID da Shared Memory */
  int SharedMemID;

  /* Ponteiro para a Shared Memory */
  int *SharedMemPtr;
  
  /* Chave misteriosa */
  key_t mykey;

  /* Ponteiros para os arquivos com os ID's do PRODUTOR e do CONSUMIDOR */
  FILE *Produtor, *Consumidor;

  // inicializa os tempos mximo, mnimo e mdio
  MinTime = 0;
  MaxTime = 0;
  MedTime = 0;

  /* Pega a chave misteriosa */
  mykey = ftok("misterioso", 1);

  printf("\nmykey is %d\n\n", mykey);
  if ( ( SharedMemID = shmget(mykey , SHM_SIZE, SHM_MODE) ) < 0 ) {
    errocode("Error in shmget", errno);
  }

  if ( ( SharedMemPtr = shmat(SharedMemID, 0, 0) ) == (void *) -1) {
    erro("Can't attach shared memory");
  }

  printf("shared memory attached from %x to %x\n\n",
	 SharedMemPtr, SharedMemPtr + SHM_SIZE);

  /* Pega o process ID do consumidor */
  ProcessID_cons = getpid();

  /* Cria arquivo "consumidor.pid" que contem o ID do CONSUMIDOR */
  Consumidor = fopen("consumidor.pid","w");
  
  if (Consumidor == NULL) {
    printf("\n\nNao foi possivel criar o arquivo consumidor.pid\n\n\n!!!");
    exit(1);
  }

  fprintf(Consumidor, "%ld", ProcessID_cons);
  fclose(Consumidor);

  signal(SIGUSR1, sig_usr1);
  signal(SIGUSR2, sig_usr2);


/*
  Verifica se j existe o arquivo "produtor.pid", ou seja, 
  se o PRODUTOR j esta rodando, caso no esteja, espera.
  Esse controle  feito pela varivel parou, que indica se o 
  programa em questo entrou em execuo primeiro ou no
*/

  parou = 0;
  do {
    Produtor = fopen("produtor.pid", "r");
    if (Produtor != NULL) { /* O PRODUTOR j estava rodando */
      fscanf(Produtor, "%ld", &ProcessID_prod);
      if (parou == 0) {
	/* "Acorda" o PRODUTOR que estava esperando o CONSUMIDOR. */
	printf("Enviando Process ID para o PRODUTOR...\n");
	kill(ProcessID_prod, SIGUSR1);
	printf("Process ID enviado...\n\n");
      }
    }
    else { /* O PRODUTOR no est rodando ainda...*/
      parou = 1;
      printf("Aguardando Process ID do PRODUTOR...\n");
      pause();
      printf("Process ID recebido...\n\n");
    }
  } while (Produtor == NULL); /* Espera at PRODUTOR entrar em execuo */

  printf("Iniciando o consumo...\n\n");

  {
    int total;        /* Varivel auxiliar usada para imprimir o total de
		        produtos no BUFFER no momento do consumo do pro-
			ximo "item"                                      */

    int item;        /* Guarda o "item" consumido                       */
    int *QuerEntrar; /* Usado pelo algoritmo de PETERSON                */
    int *QualProc;   /* Usado pelo algoritmo de PETERSON                */
    int *BUFFER;     /* BUFFER (fila circular) onde ficaro os produtos */
    int *IniBuffer;  /* Inicio da fila no Buffer                        */
    int *FimBuffer;  /* Final da fila no Buffer                         */
    double time_aux;

    QuerEntrar = SharedMemPtr;     /* Primeiras 2 posicoes da Shared Memory  */
    QualProc   = SharedMemPtr + 2; /* Terceira posicao da Shared Memory      */
    IniBuffer  = SharedMemPtr + 3; /* Quarta posicao da Shared Memory        */
    FimBuffer  = SharedMemPtr + 4; /* Quinta posicao da Shared Memory        */
    BUFFER     = SharedMemPtr + 5; /* TODO o resto da Shared Memory          */

    if (parou == 1)
      *IniBuffer = *FimBuffer = 0;

    srand(6); /* Seta a semente para 6. */

    // Laco infinito de produo e compartilhamento de memria...
    while(1) {
      time_aux = Entra_Regiao_Critica(1, QualProc, QuerEntrar);
      if (distancia(*IniBuffer, *FimBuffer) == 0) { /* BUFFER vazio */
	Sai_Regiao_Critica(1, QuerEntrar);
	time_aux = (double)clock();
	pause(); /* Espera sinal do PRODUTOR para voltar a consumir... */
	time_aux = Entra_Regiao_Critica(1, QualProc, QuerEntrar);
      }

      if(time_aux >= MaxTime) MaxTime = time_aux;
      if(time_aux <= MinTime) MinTime = time_aux;
      MedTime += time_aux;

      /* Remove o "item" do BUFFER que est no local indicado por
	 "posicao" e devolve para a varivel "item". */
      item = remove_item(*IniBuffer, BUFFER);
      *IniBuffer = (*IniBuffer + 1) % TAM_BUFFER;

      /* Atualiza o nmero de produtos no BUFFER:
         "total"  usada como dito acima, apenas para no fazer uma
	 impresso dentro da REGIAO CRITICA. E ao fazer fora dela,
	 nao perdemos a verdadeira quantia de produtos do BUFFER no
	 momento do consumo. */
      total = distancia(*IniBuffer, *FimBuffer);

      if (total == TAM_BUFFER - 2) { //O BUFFER estava cheio
	/* Manda sinal para o PRODUTOR avisando que j pode ser 
	   produzido um novo item e colocado no BUFFER */
	kill(ProcessID_prod, SIGUSR2);
      }
      Sai_Regiao_Critica(1, QuerEntrar);

      consome_item(item); /* Consome o item obtido acima */
      printf("Item consumido: %3d ", item);
      printf("Restante: %3d \n", total);
      printf("tempos ate o momento => max: %.2f/ min: %.2f/ med: %.2f\n",
	     MaxTime, MinTime, total ? MedTime / total : 0);
    }// while(1)
  }
  
  if (shmdt(SharedMemPtr) < 0) {
    erro("Can't detach shared memory");
  }

  exit(0);
}// main

/*****************************************************************************/
/** Entra_Regiao_Critica(i, QualProc, QuerEntrar)                           **/
/*****************************************************************************/
/* Funo que coloca os processos na REGIO CRTICA.
   Usa o algortmo de PETERSON. */

double Entra_Regiao_Critica(int i, int *QualProc, int *QuerEntrar) {
  int outro = 1 - i; /* 0 ou 1; oposto de i */
  clock_t start, finish;
  QuerEntrar[i] = 1; /* marca que o processo i quer entrar */
  *QualProc = i;
  start = clock();
  /* aguarda at que o processo possa entrar na regio crtica */
  while((QuerEntrar[outro]) == 1 && (*QualProc == i));
  finish = clock();
  return (((double)(finish - start)) / CLOCKS_PER_SEC);
}


/*****************************************************************************/
/** Sai_Regiao_Critica(i, QuerEntrar)                                       **/
/*****************************************************************************/
/* Funo que libera a REGIO CRTICA.
   Tambm do algortmo de PETERSON. */

void Sai_Regiao_Critica(int i, int *QuerEntrar) {
  QuerEntrar[i] = 0; /* desmarca o processo da regio crtica */
}


/*****************************************************************************/
/** consome_item(item)                                                      **/
/*****************************************************************************/
/* Funo que se encarrega de consumir o item retirado
   do BUFFER da REGIAO CRITICA... */

void consome_item(int item){
  usleep(rand() % 1000000);
}

/*****************************************************************************/
/** remove_item(IniBuffer, BUFFER)                                          **/
/*****************************************************************************/
/* Funo que se encarrega de remover um item do BUFFER da REGIO CRTICA.   */

int remove_item(int IniBuffer, int *BUFFER){
  return BUFFER[IniBuffer];
}


/* Usa o sinal SIGUSR1 */
static void sig_usr1() {
  signal(SIGUSR1, sig_usr1);
}


/* Usa o sinal SIGUSR2 */
static void sig_usr2() {
  signal(SIGUSR2, sig_usr2);
}


/*****************************************************************************/
/** erro(msg)                                                               **/
/*****************************************************************************/
/* Imprime mensagens de erro e sai do programa. */

void erro(char *msg) {
  printf("%s\n", msg);
  exit(1); /* Sai do programa */
}


/*****************************************************************************/
/** errocode(msg, code)                                                     **/
/*****************************************************************************/
/* Imprime mensagens de erro de alguns casos especiais */

void errocode(char *msg, int code) {
  printf("%s\n", msg);
  switch (code) {
  case EACCES: printf("EACCES\n");
    break;
  case EEXIST: printf("EEXIST\n");
    break;
  case EINVAL: printf("EINVAL\n");
    break;
  case ENOENT: printf("ENOENT\n");
    break;
  case ENOMEM: printf("ENOMEM\n");
    break;
  case ENOSPC: printf("ENOSPC\n");
    break;
  }
  exit(1); /* Sai do programa */
}
