/*****************************************************************************/
/******                                                                 ******/
/******                   Primeiro Semestre de 2001                     ******/
/******                                                                 ******/
/******      Primeiro programa de MAC-438 Programacao Concorrente       ******/
/******      Data de entrega: Quarta feira 01 de Setembo                ******/
/******      Professor: Francisco Reverbel                              ******/
/******                                                                 ******/
/******      Nomes:                                                     ******/
/******                                                                 ******/
/******        Hugo Kotsubo                       N. USP: 2957620       ******/
/******        Levi Fukumori                      N. USP: 2995112       ******/
/******                                                                 ******/
/*****************************************************************************/

/*****************************************************************************/
/******                            PRODUTOR.C                           ******/
/*****************************************************************************/

#include "sharemem.h"

/********************     PRODUTOR    *********************/

int main() {

  // variaveis para guardar os tempos de disputa da regiao critica
  double MaxTime, MinTime, MedTime;

  int parou; /* Variavel de controle, eh explicada mais abaixo. */
 
  /* Process ID do CONSUMIDOR */
  int ProcessID_cons;

  /* Process ID do PRODUTOR */
  int ProcessID_prod;

  /* ID da Shared Memory */
  int SharedMemID;

  /* Ponteiro para a Share Memory */
  int *SharedMemPtr;
  
  /* Chave misteriosa */
  key_t mykey;

  /* Ponteiros para os arquivos com os ID's do PRODUTOR e do CONSUMIDOR */
  FILE *Produtor, *Consumidor;

  // inicializa os tempos mximo, mnimo e mdio
  MaxTime = MedTime = 0;
  MinTime = 0xefffffff;

  /* Pega a CHAVE MISTERIOSA */
  mykey = ftok("misterioso", 1);

  printf("\nmykey is %d\n\n", mykey);
  if ((SharedMemID = shmget(mykey , SHM_SIZE, SHM_MODE)) < 0 ) {
    errocode("Error in shmget", errno);
  }

  if ((SharedMemPtr = shmat(SharedMemID, 0, 0)) == (void *) -1) {
    erro("Can't attach shared memory");
  }

  printf("shared memory attached from %x to %x\n\n",
	 SharedMemPtr, SharedMemPtr + SHM_SIZE);
  
  /* Pega o process ID do produtor */
  ProcessID_prod = getpid();
  
  /* Cria arquivo "produtor.pid" que conterah o ID do PRODUTOR */
  Produtor = fopen("produtor.pid", "w");
  
  if (Produtor == NULL) {
    printf("\n\nNao foi possivel criar o arquivo 'produtor.pid'!!!\n\n\n");
    exit(1);
  }
  
  fprintf(Produtor, "%ld", ProcessID_prod);
  fclose(Produtor);
  
  signal(SIGUSR1, sig_usr1);
  signal(SIGUSR2, sig_usr2);
  
  
/*
  Verifica se ja existe o arquivo "consumidor.pid", ou seja, 
  se o CONSUMIDOR ja esta rodando, caso nao esteja, espera.
  Esse controle e feito pela variavel parou, que indica se o 
  program em questao entrou primeiro em execucao, ou nao.
*/
  parou = 0;
  do {
    Consumidor = fopen("consumidor.pid", "r");
    if (Consumidor != NULL) { /* O CONSUMIDOR ja estava rodando */
      fscanf(Consumidor, "%ld", &ProcessID_cons); 
      if (parou == 0) {
	/* "Acorda" o CONSUMIDOR que estava esperando o PRODUTOR. */
	printf("Enviando sinal para 'acordar' CONSUMIDOR...\n");
	kill(ProcessID_cons, SIGUSR1); 
	printf("Sinal enviado.\n\n");
      }
    }
    else { /* O CONSUMIDOR no est rodando ainda... */
      parou = 1;
      printf("Aguardando o Process ID do CONSUMIDOR...\n");
      pause();
      printf("Process ID recebido...\n\n");
    }
  } while (Consumidor == NULL); /* Espera ate CONUMIDOR entrar em execucao */
  
  printf("Produzindo...\n\n");
  
  {
    int total;       /* Variavel auxiliar usada para imprimir o total de
		        produtos no BUFFER no momento da producao do ul-
			timo "item"                                     */
    int item;        /* Guarda o "item" produzido                       */
    int *QuerEntrar; /* Usado pelo algortmo de PETERSON                */
    int *QualProc;   /* Usado pelo algortmo de PETERSON                */
    int *BUFFER;     /* BUFFER (fila circular) onde ficaro os produtos */  
    int *IniBuffer;  /* Inicio da fila no Buffer                        */
    int *FimBuffer;  /* Final da fila no Buffer                         */
    double time_aux;

    QuerEntrar = SharedMemPtr;     /* Primeiras 2 posicoes da Shared Memory  */
    QualProc   = SharedMemPtr + 2; /* Terceira posicao da Shared Memory      */
    IniBuffer  = SharedMemPtr + 3; /* Quarta posicao da Shared Memory        */
    FimBuffer  = SharedMemPtr + 4; /* Quinta posicao da Shared Memory        */
    BUFFER     = SharedMemPtr + 5; /* TODO o resto da Shared Memory          */
    
    
    /* Como est entrando s agora em execuo, inicializa a fila,
       pois pode estar suja e com isso, o CONSUMIDOR pode tentar
       consumir essa sujeira. Ou o prprio PRODUTOR pode querer us-la.  */
    if (parou == 1)
      *IniBuffer = *FimBuffer = 0;

    srand(5); /* Seta a semente para 5 */
    
    // Laco infinito de producao e compartilhamento de memria
    while(1) {
      produz_item(&item); /* Produz um inteiro aleatrio */
      
      time_aux = Entra_Regiao_Critica(0, QualProc, QuerEntrar);

      if(time_aux > MaxTime) MaxTime = time_aux;
      if(time_aux < MinTime) MinTime = time_aux;
      MedTime += time_aux;

      if (distancia(*IniBuffer, *FimBuffer) == TAM_BUFFER - 1) {//BUFFER cheio
	Sai_Regiao_Critica(0, QuerEntrar);
	pause(); /* Espera sinal do CONSUMIDOR para voltar a produzir */
	Entra_Regiao_Critica(0, QualProc, QuerEntrar);
      }
      
      /* FimBuffer = (*NumProd);  Posicao onde o item deve ser inserido   */
      
      /* Coloca o "item" no BUFFER bem no local indicado por "posicao" */
      entra_item(item, *FimBuffer, BUFFER);
      
      /* Atualiza o numero de produtos no BUFFER:
         "total" eh usada como dito acima, apenas para nao fazer uma
	 impressao dentro da REGIAO CRITICA. E ao fazer fora dela,
	 nao pedermos a verdadeira quantia de produtos do BUFFER no
	 momento da producao. */
      *FimBuffer = (*FimBuffer + 1) % TAM_BUFFER;
      total = distancia(*IniBuffer, *FimBuffer);

      if (total == 1) { /* O BUFFER estava vazio */
	/* Manda sinal para o CONSUMIDOR avisando que j h
	   produtos disponiveis para consumo no BUFFER  */
	kill(ProcessID_cons, SIGUSR2);
      }
      Sai_Regiao_Critica(0, QuerEntrar);
      printf("Item Produzido: %d Total de produtos: %d\n", item , total);
      printf("tempos ate o momento => max: %.2f/ min: %.2f/ med: %.2f\n",
	     MaxTime, MinTime, total ? MedTime / ((double)total) : 0);
    }// while(1)
  }
  
  if (shmdt(SharedMemPtr) < 0) {
    erro("\nCan't detach shared memory\n");
  }
  exit (0);
}// main


/*****************************************************************************/
/** Entra_Regiao_Critica(i, QualProc, QuerEntrar)                           **/
/*****************************************************************************/
/* Funo que coloca os processos na REGIO CRTICA.
   Usa o algortmo de PETERSON. */

double Entra_Regiao_Critica(int i, int *QualProc, int *QuerEntrar) {
  int outro = 1 - i; /* 0 ou 1; oposto de i */
  clock_t finish;
  clock_t start;
  QuerEntrar[i] = 1; /* marca que o processo i quer entrar */
  *QualProc = i;

  start = clock();
  /* aguarda at que o processo possa entrar na regio crtica */
  while((QuerEntrar[outro] == 1) && (*QualProc == i));
  finish = clock();
  return ((double) finish - start) / CLOCKS_PER_SEC;
}

/*****************************************************************************/
/** Sai_Regiao_Critica(i, QuerEntrar)                                       **/
/*****************************************************************************/
/* Funo que libera a REGIO CRTICA.
   Tambm do algortmo de PETERSON. */

void Sai_Regiao_Critica(int i, int *QuerEntrar) {
  QuerEntrar[i] = 0; /* desmarca o processo da regio crtica */
}


/*****************************************************************************/
/** produz_item(item)                                                       **/
/*****************************************************************************/
/* Funo que se encarrega de produzir um item (gera um inteiro aleatrio)
   que ser colocado no BUFFER da REGIO CRTICA. */

void produz_item(int *item) {
  *item = (rand() % 600);
  usleep(rand() % 100000);
}


/*****************************************************************************/
/** entra_item(item, FimBuffer, BUFFER)                                     **/
/*****************************************************************************/
/* Funo que se encarrega INSERIR o item produzido no BUFFER */

void entra_item(int item, int FimBuffer, int *BUFFER) {
  BUFFER[FimBuffer] = item;
}

/* Usa o sinal SIGUSR1 */
static void sig_usr1() {
  signal(SIGUSR1, sig_usr1);
}


/* Usa o sinal SIGUSR2 */
static void sig_usr2() {
  signal(SIGUSR2, sig_usr2);
}


/*****************************************************************************/
/** erro(msg)                                                               **/
/*****************************************************************************/
/* Imprime mensagens de erro e sai do programa. */

void erro(char *msg) {
  printf("%s\n", msg);
  exit(1); /* Sai do programa */
}


/*****************************************************************************/
/** errocode(msg, code)                                                     **/
/*****************************************************************************/
/* Imprime mensagens de erro de alguns casos especiais */

void errocode(char *msg, int code) {
  printf("%s\n", msg);
  switch (code) {
  case EACCES: printf("EACCES\n");
    break;
  case EEXIST: printf("EEXIST\n");
    break;
  case EINVAL: printf("EINVAL\n");
    break;
  case ENOENT: printf("ENOENT\n");
    break;
  case ENOMEM: printf("ENOMEM\n");
    break;
  case ENOSPC: printf("ENOSPC\n");
    break;
  }
  exit(1); /* Sai do programa */
}
